!2017/01/24
!2017/01/25

module mod_pollackcloud

  use mod_clscat6
  implicit none

  private

  public :: cloudlayerprop
  public :: cloudproperties
  public :: pollackcloud_Press

contains

  subroutine cloudlayerprop (                   &
    & kmax, r_Press, WaveNum, Rmed, Rre, Rim,   & ! (in )
    & zb_DelOptDep, zb_SingleScatA, zb_AsymFact ) ! (out)

    integer, intent(in ) :: kmax
    real(8), intent(in ) :: r_Press(0:kmax)
    real(8), intent(in ) :: WaveNum
    real(8), intent(in ) :: Rmed
    real(8), intent(in ) :: Rre
    real(8), intent(in ) :: Rim
    real(8), intent(out) :: zb_DelOptDep  (1:kmax, 1:4)
    real(8), intent(out) :: zb_SingleScatA(1:kmax, 1:4)
    real(8), intent(out) :: zb_AsymFact   (1:kmax, 1:4)

    real(8) :: a_CloudPress (-1:6)
    integer :: amax = 6
    real(8) :: ab_DelOptDepRef(0:6,1:4)
    real(8) :: b_ExtCrossSecRef(1:4)
    real(8) :: b_ExtCrossSec(1:4)
    real(8) :: b_SingleScatA(1:4)
    real(8) :: b_AsymFact   (1:4)
    real(8) :: b_ExtCSRatio (1:4)
    integer :: bmax = 4
    integer :: k_a, k_b, k_r
    integer :: k_lay, k_count, k_amax

    real(8) :: SumOptDep
    character( 6) :: CharMode(1:4)

    CharMode(1:4) = (/'Mode1 ', 'Mode2 ', "Mode2'", 'Mode3 '/)

    call pollackcloud_Press ( &
      & a_CloudPress(0:6)         ) ! (out)

    a_CloudPress(-1) = 1d+100
    !print *, '==CloudPress'
    !do k_a = 0, amax
    !  print *, a_CloudPress(k_a)
    !end do

    call pollackcloud_ExtCrossSec ( &
      & b_ExtCrossSecRef            ) ! (out)

    !print *, '==ExtCrossSecRef'
    !do k_b = 1, bmax
    !  print *, b_ExtCrossSecRef(k_b)
    !end do

    ab_DelOptDepRef = 0.0_8
    call pollackcloud_OptDep ( &
      & ab_DelOptDepRef(1:6,1:4)  ) ! (out)

    !print *, '==DelOptDepRef'
    !do k_b = 1, bmax
    !  print *, k_b
    !  do k_a = 1, amax
    !    print *, ab_DelOptDepRef(k_a,k_b)
    !  end do
    !end do


    !if(.false.) then
    call  cloudproperties (                    &
      & WaveNum, Rmed, Rre, Rim,               & ! (in )
      & b_ExtCrossSec, b_SingleScatA, b_AsymFact ) ! (out)
    !else
    !!ExtCrossSec
    !  b_ExtCrossSec = 1.9322888683947158d-012
    !!SingleScatA
    !  b_SingleScatA = 0.9999998628521010d0
    !!AsymFact
    !  b_AsymFact = -5.8969385807839850d-002
    !end if

    b_ExtCSRatio(1:4) = b_ExtCrossSec(1:4)/b_ExtCrossSecRef(1:4)

    do k_r = 1, kmax
      zb_SingleScatA(k_r,1:4) = b_SingleScatA(1:4)
      zb_AsymFact   (k_r,1:4) = b_AsymFact   (1:4)
    end do

    !print *, '==ExtCSRatio'
    !do k_b = 1, bmax
    !  print *, b_ExtCSRatio(k_b)
    !end do

    !print *, '== optdep layer calculation start'
    zb_DelOptDep = 0.0_8

    k_a = 0
    do k_r = 1, kmax
      if(r_Press(k_r) .ge. a_CloudPress(k_a)) then
        zb_DelOptDep(k_r,1:4) = 0.0_8
      else
        !print *, '==check: P (<) CP'
        !print *, r_Press(k_r), a_CloudPress(k_a)
        k_lay = k_r
        !print *, 'higher layer below the cloud bottom'
        !print *, 'k_lay-1', k_lay-1, r_Press(k_lay-1)
        exit
      end if
    end do ! k_r

    k_amax = 0
    do k_r = k_lay, kmax
      k_count = 0
      !print *, '=ABOUT below delta P layer', k_r
      !print *, r_Press(k_r-1), r_Press(k_r)
      !print *, '== cloud boundary in delta P'
      do k_a = 0, amax
        if( (r_Press(k_r-1) .gt. a_CloudPress(k_a)) .and. (r_Press(k_r) .le. a_CloudPress(k_a) )) then
          k_count = k_count + 1
          k_amax = k_a
          !print *, a_CloudPress(k_a)
        end if
      end do ! k_a in k_r
      !print *, 'count, amax', k_count, k_amax
      !if(k_count .ne. 0) then
      !  do k_a = k_amax, k_amax-k_count+1, -1
      !    print *, a_CloudPress(k_a)
      !  end do ! k_a in k_r
      !end if

      !print *, '==check boundary'
      !print *, 'Cloud', a_CloudPress(k_amax-k_count)
      !print *, r_Press(k_r-1), r_Press(k_r)
      !if(k_amax .le. amax-1) then
      !  print *, 'Cloud', a_CloudPress(k_amax+1)
      !else
      !  print *, 'k_amamx is NOT .le. amax-1, k_amax:', k_amax
      !end if

      !print *, '==boundary sort check'
      if(k_count .eq. 0) then
        !print *, 'cloud boundary is not include'
        !print *, a_CloudPress(k_amax-k_count), 'Cloud boundary below r_P bottom'
        !print *, r_Press(k_r-1), 'r_P bottom'
        !print *, r_Press(k_r), 'r_P top'

        zb_DelOptDep(k_r,1:4) = b_ExtCSRatio(1:4)*ab_DelOptDepRef(k_amax+1,1:4)*&
          & (r_Press(k_r-1)-r_Press(k_r))/(a_CloudPress(k_amax-k_count)-a_CloudPress(k_amax+1))

        !print *, 'delOptDep', zb_DelOptDep(k_r,1)
        !print *, 'ExtCSRatio', b_ExtCSRatio(1)
        !print *, 'DelOptDepRef', ab_DelOptDepRef(k_amax+1,1)
        !print *, 'deltaP',(r_Press(k_r-1)-r_Press(k_r))
        !print *, 'deltaPCloud', (a_CloudPress(k_amax-k_count)-a_CloudPress(k_amax+1))

      else
        zb_DelOptDep(k_r,1:4) = 0.0_8

        !print *, k_count, 'cloud boundary is include'
        !print *, a_CloudPress(k_amax-k_count), 'Cloud boundary below r_P bottom'
        !print *, r_Press(k_r-1), 'r_P bottom'

        zb_DelOptDep(k_r,1:4) = zb_DelOptDep(k_r,1:4) + &
          & b_ExtCSRatio(1:4)*ab_DelOptDepRef(k_amax-k_count+1,1:4)*&
          & (r_Press(k_r-1)-a_CloudPress(k_amax-k_count+1))/(a_CloudPress(k_amax-k_count)-a_CloudPress(k_amax-k_count+1))

        !print *, 'delOptDep', zb_DelOptDep(k_r,1)
        !print *, 'ExtCSRatio', b_ExtCSRatio(1)
        !print *, 'DelOptDepRef', ab_DelOptDepRef(k_amax-k_count+1,1)
        !print *, 'Pb - PCloud',(r_Press(k_r-1)-a_CloudPress(k_amax-k_count+1))
        !print *, 'deltaPCloud', (a_CloudPress(k_amax-k_count)-a_CloudPress(k_amax-k_count+1))

        if(k_count .ne. 1) then
          do k_a = k_amax-k_count+1, k_amax-1
            !print *, a_CloudPress(k_a), 'Cloud boundary'
            zb_DelOptDep(k_r,1:4) = zb_DelOptDep(k_r,1:4) + &
              & b_ExtCSRatio(1:4)*ab_DelOptDepRef(k_a+1  ,1:4)
            !print *, 'DelOptDepRef', ab_DelOptDepRef(k_a+1, 1)
          end do
        end if

        !print *, a_CloudPress(k_amax), 'Cloud boundary'


        if(k_amax .le. amax-1) then
          zb_DelOptDep(k_r,1:4) = zb_DelOptDep(k_r,1:4) + &
            & b_ExtCSRatio(1:4)*ab_DelOptDepRef(k_amax+1,1:4)*&
            & (a_CloudPress(k_amax)-r_Press(k_r))/(a_CloudPress(k_amax)-a_CloudPress(k_amax+1))

          !print *, 'delOptDep', zb_DelOptDep(k_r,1)
          !print *, 'ExtCSRatio', b_ExtCSRatio(1)
          !print *, 'DelOptDepRef', ab_DelOptDepRef(k_amax+1,1)
          !print *, 'PCloud - Pt',(a_CloudPress(k_amax)-r_Press(k_r))
          !print *, 'deltaPCloud', (a_CloudPress(k_amax)-a_CloudPress(k_amax+1))
        end if

        !print *, r_Press(k_r), 'r_P top'
      end if

      !if(k_amax .le. amax-1) then
      !  print *, a_CloudPress(k_amax+1), 'Cloud boundary over r_P top'
      !else
      !  print *, 'k_amamx is NOT .le. amax-1, k_amax:', k_amax
      !end if
      !print *, '== '

      !print *, 'zb_DelOptDep', k_r
      !print *, zb_DelOptDep(k_r,1)

    end do

    SumOptDep = 0.0_8
    do k_r = 1, kmax
      SumOptDep = SumOptDep + zb_DelOptdep(k_r,1)
    end do
    print *, '==SUM OPTDEP'
    print *, SumOptDep


    do k_b = 1, bmax
      do k_r = 1, kmax
        if(zb_delOptDep(k_r,k_b) .eq. 0.0_8) then
          zb_SingleScatA(k_r,k_b) = 0.0_8
          zb_AsymFact   (k_r,k_b) = 0.0_8
        end if
      end do
    end do ! k_b


    print *, '==DelOptDep, SingleScatA, AsymFact'
    do k_b = 1, bmax
      print *, CharMode(k_b)
      do k_r = 1, kmax
        !print *, r_Press(k_r-1), r_Press(k_r)
        print *, zb_DelOptDep(k_r,k_b), zb_SingleScatA(k_r,k_b), zb_AsymFact(k_r,k_b)
      end do
    end do

  end subroutine cloudlayerprop

  subroutine cloudproperties (               &
    & WaveNum, Rmed, Rre, Rim,               & ! (in )
    & b_ExtCrossSec, b_SingleScatA, b_AsymFact ) ! (out)

    real(8), intent(in ) :: WaveNum
    real(8), intent(in ) :: Rmed
    real(8), intent(in ) :: Rre
    real(8), intent(in ) :: Rim
    real(8), intent(out) :: b_ExtCrossSec(1:4)
    real(8), intent(out) :: b_SingleScatA(1:4)
    real(8), intent(out) :: b_AsymFact   (1:4)
    real(8) :: b_RmeanRef (1:4)
    real(8) :: b_RsigmaRef(1:4)
    integer :: bmax = 4 ! particle mode number
    integer :: k_b

    call pollackcloud_Rmean ( b_RmeanRef  )
    call pollackcloud_Rsigma( b_RsigmaRef )

    !print *, b_RmeanRef
    !print *, b_RsigmaRef

    do k_b = 1, bmax
      call miescat(                                              & ! 2017/01/23 onishi
        & WaveNum, b_RmeanRef(k_b), b_RsigmaRef(k_b),            & ! (in )
        & Rmed, Rre, Rim,                                        & ! (in )
        & b_ExtCrossSec(k_b), b_SingleScatA(k_b), b_AsymFact(k_b)) ! (out)

      print *, 'ExtCrossSec'
      print *, b_ExtCrossSec(k_b)
      print *, 'SingleScatA'
      print *, b_SingleScatA(k_b)
      print *, 'AsymFact'
      print *, b_AsymFact(k_b)

    end do ! k_b

  end subroutine cloudproperties

  subroutine pollackcloud_Rmean ( &
    & b_Rmean                     ) ! (out)

    real(8), intent(out) :: b_Rmean(1:4) ![m]

    b_Rmean(1:4) =(/0.30d-6, 1.00d-6, 1.40d-6, 3.65d-6/)

  end subroutine pollackcloud_Rmean

  subroutine pollackcloud_Rsigma ( &
    & b_Rsigma                     ) ! (out)

    real(8), intent(out) :: b_Rsigma(1:4) ![1]

    b_Rsigma(1:4) =(/1.56d0, 1.29d0, 1.23d0, 1.28d0/)

  end subroutine pollackcloud_Rsigma

  subroutine pollackcloud_ExtCrossSec ( &
    & b_ExtCrossSec                     ) ! (out)

    real(8), intent(out) :: b_ExtCrossSec(1:4) ![1]

    ! wavelength = 0.63 micron
    ! Rre = 1.429
    ! Rim = 1.42d-8
    !
    b_ExtCrossSec(1:4) =(/1.9322888683947158E-012, &
      &                   9.6768783328106845E-012, &
      &                   1.7137084300148607E-011, &
      &                   1.1553187570772454E-010 /)

  end subroutine pollackcloud_ExtCrossSec

  subroutine pollackcloud_OptDep ( &
    & ab_OptDep                    ) ! (out)

    real(8), intent(out) :: ab_OptDep(1:6, 1:4) ![1]

    ! 'a's number is NOT layer number of Pollack
    ! a = 1 is layer 6 in Pollack (1993), bottom layer
    ! a = 6 is layer 1 in Pollack (1993), top layer
    !
    ab_OptDep(1,1:4) = (/1.6d0 , 0.0d0 , 2.31d0, 5.44d0/)
    ab_OptDep(2,1:4) = (/0.5d0 , 0.0d0 , 2.5d0 , 2.4d0 /)
    ab_OptDep(3,1:4) = (/0.23d0, 0.0d0 , 0.5d0 , 0.2d0 /)
    ab_OptDep(4,1:4) = (/1.0d0 , 0.2d0 , 0.0d0 , 0.0d0 /)
    ab_OptDep(5,1:4) = (/2.17d0, 7.92d0, 0.0d0 , 0.4d0 /)
    ab_OptDep(6,1:4) = (/0.0d0 , 0.0d0 , 0.0d0 , 0.0d0 /)

  end subroutine pollackcloud_OptDep

  subroutine pollackcloud_Press ( &
    & a_Press                     ) ! (out)

    real(8), intent(out) :: a_Press(0:6) ![1]

    a_Press(0:6) =(/1.4d+5, 1.0d+5, 6.0d+4, 3.89d+4, &
      &             1.156d+4, 1.7d+2, 0.0d0/)

  end subroutine pollackcloud_Press

end module mod_pollackcloud
